// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	tharsis "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// Run is an autogenerated mock type for the Run type
type Run struct {
	mock.Mock
}

// ApplyRun provides a mock function with given fields: ctx, input
func (_m *Run) ApplyRun(ctx context.Context, input *types.ApplyRunInput) (*types.Run, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Run
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.ApplyRunInput) (*types.Run, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.ApplyRunInput) *types.Run); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Run)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.ApplyRunInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CancelRun provides a mock function with given fields: ctx, input
func (_m *Run) CancelRun(ctx context.Context, input *types.CancelRunInput) (*types.Run, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Run
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CancelRunInput) (*types.Run, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CancelRunInput) *types.Run); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Run)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CancelRunInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateRun provides a mock function with given fields: ctx, input
func (_m *Run) CreateRun(ctx context.Context, input *types.CreateRunInput) (*types.Run, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Run
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateRunInput) (*types.Run, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateRunInput) *types.Run); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Run)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateRunInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetRun provides a mock function with given fields: ctx, input
func (_m *Run) GetRun(ctx context.Context, input *types.GetRunInput) (*types.Run, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Run
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetRunInput) (*types.Run, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetRunInput) *types.Run); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Run)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetRunInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetRunPaginator provides a mock function with given fields: ctx, input
func (_m *Run) GetRunPaginator(ctx context.Context, input *types.GetRunsInput) (*tharsis.RunPaginator, error) {
	ret := _m.Called(ctx, input)

	var r0 *tharsis.RunPaginator
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetRunsInput) (*tharsis.RunPaginator, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetRunsInput) *tharsis.RunPaginator); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*tharsis.RunPaginator)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetRunsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetRunVariables provides a mock function with given fields: ctx, input
func (_m *Run) GetRunVariables(ctx context.Context, input *types.GetRunInput) ([]types.RunVariable, error) {
	ret := _m.Called(ctx, input)

	var r0 []types.RunVariable
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetRunInput) ([]types.RunVariable, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetRunInput) []types.RunVariable); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]types.RunVariable)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetRunInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetRuns provides a mock function with given fields: ctx, input
func (_m *Run) GetRuns(ctx context.Context, input *types.GetRunsInput) (*types.GetRunsOutput, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.GetRunsOutput
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetRunsInput) (*types.GetRunsOutput, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetRunsInput) *types.GetRunsOutput); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.GetRunsOutput)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetRunsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SetVariablesIncludedInTFConfig provides a mock function with given fields: ctx, input
func (_m *Run) SetVariablesIncludedInTFConfig(ctx context.Context, input *types.SetVariablesIncludedInTFConfigInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.SetVariablesIncludedInTFConfigInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// SubscribeToWorkspaceRunEvents provides a mock function with given fields: ctx, input
func (_m *Run) SubscribeToWorkspaceRunEvents(ctx context.Context, input *types.RunSubscriptionInput) (<-chan *types.Run, error) {
	ret := _m.Called(ctx, input)

	var r0 <-chan *types.Run
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.RunSubscriptionInput) (<-chan *types.Run, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.RunSubscriptionInput) <-chan *types.Run); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(<-chan *types.Run)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.RunSubscriptionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewRun interface {
	mock.TestingT
	Cleanup(func())
}

// NewRun creates a new instance of Run. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewRun(t mockConstructorTestingTNewRun) *Run {
	mock := &Run{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
